<?php
/**
 * MAIN PAGE
 *
 * PHP version 5
 *
 * LICENSE: This source file is subject to version 3.0 of the PHP license
 * that is available through the world-wide-web at the following URI:
 * http://www.php.net/license/3_0.txt.  If you did not receive a copy of
 * the PHP License and are unable to obtain it through the web, please
 * send a note to license@php.net so we can mail you a copy immediately.
 *
 * @category   NA
 * @package    NA
 * @author     Nicolas Bruley / Peer 2 World <contact@weezo.net>
 * @copyright  2005-2009 Nicolas Bruley / Peer 2 World
 * @license    http://www.php.net/license/3_0.txt  PHP License 3.0
 * @version    CVS: $Id:$
 * @link       http://www.weezo.net
 * @since      File available since Release 1.0.0
 */

/**
 * @desc logout user
 *
 */
function indexLogout(){
	$logoutToLoginPage=cfGGetVar('logoutToLoginPage');

	// if user is actually connected
	if (isset($_SESSION['userLogged'])){
		// Save icon's position and persistant resources vars (only if single user profile or admin)
		if(WEnv::user()->isAdministrator() || WEnv::user()->getVar('accountType')=='singleUser' || WEnv::user()->getVar('accountType')=='list'){
			// Browse active items (background icons)
			foreach (cfGGetVar('activeItems') as $item) if($item['type']=='icon' && isset($item['resourceFilename']) && $item['x']!==null && $item['y']!==null){
				foreach (WEnv::user()->getResources() as $rid=>$rfn) if($rfn==$item['resourceFilename']) WEnv::user()->updateResource($rid,'iconPosition',$item['x'].'x'.$item['y']);
			}

			// Save persistant resources vars
			WEnv::user()->saveVar('savedRVars',false);

			// Save user if needed
			WEnv::user()->save();
		}

		/**
		 * Destroy session, log everything and do the cleaning
		 */
		WEnv::usersLogged()->disconnectCurrentUser();
	}
	else {
		cfLog('Log out required by non logged user (session has probably expired)',LOG_INF);
		// destroy session anyway
		wSession_destroy();
	}

	// Destroy Session cookie
	setcookie('WSESSID', '', time()-42000, '/');

	// Remove publish token if set
	if(isset($_COOKIE['weezoPublishToken'])) {setcookie('weezoPublishToken','',(time()-3600)); unset($_COOKIE['weezoPublishToken']);}

	// Remove direct resource access token if set
	if(isset($_COOKIE['weezoDirectResourceAccessToken'])) {setcookie('weezoDirectResourceAccessToken','',(time()-3600));unset($_COOKIE['weezoDirectResourceAccessToken']);}

	// Site accessed through portal
	if((/*@$_POST['logout']=='top' &&*/ !$logoutToLoginPage) || !cfDirectWebConnectionsAllowed()) {
		if(cfIsAsync()) die(cfAsyncHeader().cfAsyncJSaction('top.location.href="'.APP_SITE.'"').cfAsyncFooter(false));
		echo '<script langage="javascript">top.location.href="'.APP_SITE.'";</script>';
		exit;
	}

	// Else, go back to login page
	if(cfIsAsync()) die(cfAsyncHeader().cfAsyncJSaction('document.location.href="/index.php"').cfAsyncFooter(false));
	require_once(cfAppDocRoot().'/login.php');
	exit();
}

/**
 * Set client browser capabilities
 * Called on 1st page load (if those capabilities not set)
 */
function setClientCapabilities($caps){
	$allowedCapabilities=array(
		'flash',
		'html5VideoWebm',
		'html5VideoOgv',
		'html5VideoH264',
		'html5AudioMp3',
		'html5AudioOgv',
		'qt',
		'divx',
		'vlc',
		'wmp'
		);
	$cc=array();

	foreach ($caps as $k=>$v) if(in_array($k,$allowedCapabilities)) $cc[$k]=($v)?true:false;

	cfBSetVar('clientCapabilities',$cc);

	cfAsyncHeader();
	die(cfAsyncFooter());
}


// Start session if client send a session id
if(isset($_COOKIE['WSESSID'])) wSession_start();

/*
 ***************************************************************************************************************************
 * If logout order received, destroy & reload session
 ***************************************************************************************************************************
 */
if(isset($_POST['logout'])) indexLogout();


// Theme change command received
if(isset($_POST['themeUpdate']) && isset($_POST['themeLevel']) && cfGGetVar('allowUserThemeChange')){
	if($_POST['themeLevel']=='general') cfGSetVar('theme', cfUTF8Decode($_POST['themeUpdate']));
	if($_POST['themeLevel']=='user') cfUSetVar('theme', cfUTF8Decode($_POST['themeUpdate']));
	if($_POST['themeLevel']=='resource') cfRSetVar('theme', cfUTF8Decode($_POST['themeUpdate']));
}

if(isset($_GET['themeUpdate']) && isset($_GET['themeLevel']) && cfGGetVar('allowUserThemeChange')){
	if($_GET['themeLevel']=='general') cfGSetVar('theme', cfUTF8Decode($_GET['themeUpdate']));
	if($_GET['themeLevel']=='user') cfUSetVar('theme', cfUTF8Decode($_GET['themeUpdate']));
	if($_GET['themeLevel']=='resource') cfRSetVar('theme', cfUTF8Decode($_GET['themeUpdate']));
}
// Get user screen size
if (isset($_GET['userScreenWidth'])) cfGSetVar('userScreenWidth',$_GET['userScreenWidth']);
if (isset($_GET['userScreenHeight'])) cfGSetVar('userScreenHeight',$_GET['userScreenHeight']);

// Set client browser capabilities
if(isset($_POST['setClientCapabilities'])) setClientCapabilities($_POST);



/*
 ***************************************************************************************************************************
 * If user not logged-in, display authentication form
 ***************************************************************************************************************************
 */
if(!isset($_SESSION['userLogged'])) {
	if(isset($_GET['loginOK'])) $securityEvent=cfCaption('securityNoSession');
	require(cfAppDocRoot().'/login.php');
	exit;
}

/*
 ***************************************************************************************************************************
 * User logged-in
 ***************************************************************************************************************************
 */

// Standalone resource
if(cfUGetVar('publishToken') || cfUGetVar('directResourceAccessToken')) {
	// Bug WA when switching between DRAs
	if(!isset($_SESSION['res'][0])) {require(cfAppDocRoot().'/login.php');return;}

	// Going to /index.php always means a disconnection (as normal resource navigation should always be in /res/type/subtype folder
	// (except during login process, where loginOK GET parameter is set).
	// This is done to allow disconnection from standalone resources
	if(!isset($_GET['loginOK'])) {
		// ... but don't disconnect if token passed in URL is the same (that happends on a browser full-page refresh)
		if(cfUGetVar('directResourceAccessToken') && @$_GET['directResourceAccessToken']==cfUGetVar('directResourceAccessToken')) {}
		elseif(cfUGetVar('publishToken') && @$_GET['publishToken']==cfUGetVar('publishToken')) {}
		else indexLogout();
	}

	// In a new token is passed (publish or direct resource access), logout from currently logged and reload
	if(isset($_GET['publishToken']) && $_GET['publishToken']!=cfUGetVar('publishToken')) indexLogout();
	if(isset($_GET['directResourceAccessToken']) && $_GET['directResourceAccessToken']!=cfUGetVar('directResourceAccessToken')) indexLogout();


	// Redirect to resource (add cookie in GET as it might still not have been set (IE, Opera...).
	indexDirectResourceAccessRedirectForm($_SESSION['res'][0]['resourceJsLink'].((strpos($_SESSION['res'][0]['resourceJsLink'],'?'))?'&':'?').'WSESSID='.$_COOKIE['WSESSID']);

	exit;
}

require(cfAppDocRoot().'/mainFrame.php');
exit;

/**
 * @desc Insert a form that will, on user login, redirect from index.php to resource, and ensure that session cookie has been properly set
 *
 * @param unknown_type $url
 */
function indexDirectResourceAccessRedirectForm($url){
	//header('Location: '.$_SESSION['res'][0]['resourceJsLink'].((strpos($_SESSION['res'][0]['resourceJsLink'],'?'))?'&':'?').'WSESSID='.$_COOKIE['WSESSID']);
	cfInsertHEAD(false);
	?>
<script type="text/javascript">
var l="<?php echo $url;?>";
wl.cookie.set('WSESSID','<?php echo $_COOKIE['WSESSID']; ?>');
if(!wl.cookie.get('WSESSID')) top.location=l; else D.location=l;
</script>
<body></body>
	<?php
}