var ssh={
	'd':{}, // Characters matrix
	'w':80, // Number of columns
	'h':80, // Max number of lines
	'dx':9,'dy':9, // Character width & height, used for cursor absolute positionning
	'nbLines':0, // Number of currently created lines
	'x':0, // Cursor x position (col)
	'y':0, // Cursor y position (line)
	'lineMod':[], // Array of 0/1 for modified lines tracking (used to display only modified lines)
	'keyReady':1, // Key Ready: 1 when ready to send, 0 when a key input request is in progress
	'keyBuffer':'', // Command string buffered waiting to be sent (as soon as keyReady is 1)
	'div':0, // sshOut DIV node
	'inputActive':1, // true to re-focus on textarea on key press
	'JSCipher':0, // true to encode/decode ssh input/output with AES algorithm
	'loginOK':1, // Indicate user and password have been set. If not, Login form should be displayed
	'formats':{
		1:'font-weight:bold',
		01:'font-weight:bold',
		2:'font-weight:underline',
		02:'font-weight:underline',
		8:'visibility:hidden',
		08:'visibility:hidden',
		30:'color:black',
		31:'color:red',
		32:'color:green',
		33:'color:yellow',
		34:'color:#88F',
		35:'color:magenta',
		36:'color:cyan',
		37:'color:white',
		40:'background:black',
		41:'background:red',
		42:'background:green',
		43:'background:yellow',
		44:'background:blue',
		45:'background:magenta',
		46:'background:cyan',
		47:'background:white'
	},

	/**
	 * Send a request to server to retrieve ssh2 output
	 */
	'pull':function (){wl.asr.send('sshPull='+Math.random())},

	/**
	 * Update display with data received from server
	 */
	'updateContent':function (data){
		var t,p,c,f,format=[0,0,0],col,line;
//if(data) cfDbg(data);
		for(e in data){
			t=data[e].t;
			p=data[e].p;

//if(t!='text' && t!='m') cfDbg(t+'>'+p+'/',1);

			// Formating sequence
			if(t=='m'){
				if(p){
					f=p.split(';');
					for(i=0;i<f.length;i++) if(!isNaN(pr=f[i])){
						if(pr==0) format=[0,0,0];
						else if(pr<9) format[0]=pr;
						else if(pr>29 && pr<38) format[1]=pr;
						else if(pr>39 && pr<48) format[2]=pr;
					}
				}
				else format=[0,0,0];
			}
			// Cursor position (line;col or 0;0 if nothing specified)
			else if(t=='H' || t=='f'){
				if(!p) p='0;0';
				p=p.split(';');
				if(!isNaN(p[0])) {
					while(ssh.nbLines<p[0]) ssh.LF();
					ssh.y=p[0];
				}
				if(p.length>1 && !isNaN(p[1])) ssh.x=p[1];
			}
			// Clear end of line including char at cursor position
			else if(t=='K'){
				for(col=ssh.x;col<ssh.w;col++) ssh.setChar(' ',col,ssh.y);
			}
			// Clear n chars from cursor position
			else if(t=='P'){
				if(!isNaN(p)) for(col=ssh.x;col<ssh.x+p;col++) ssh.setChar(' ',col,ssh.y);
			}
			// Move n char right (1 if n not provided)
			else if(t=='C'){
				if(!p || !isNaN(p)) ssh.x++; else ssh.x+=p;
				if(p>ssh.w) {
					if(ssh.y<ssh.nbLines) ssh.y++; else ssh.LF();
				}
			}
			// Clear screen
			else if(t=='J' && (p==2||p=='')){
				ssh.d={};
				ssh.nbLines=0;
				ssh.y=-1;

				for(line=0;line<ssh.h;line++) ssh.LF();
			}
			// Displayable-text sequence
			else if(t=='text') {
				for(i=0;i<p.length;i++){
					ssh.setChar(p.substr(i,1),ssh.x,ssh.y,format);
					ssh.x++;
					if(ssh.x>ssh.w) {
						ssh.x=0;
						ssh.LF();
						ssh.updateDisplay()
					}
				}
			}
			// Ascii char
			else if(t=='ascii'){
				// CRLF
				if((p==13 && ssh.lineBreak=='CR') || (p==10 && ssh.lineBreak=='LF')){
					ssh.x=0;
					ssh.LF();
//cfDbg('LF',1)
				}
				else if(p==13) ssh.x=0;
				else if(p==10 && ssh.lineBreak=='CRLF') {
					ssh.LF();
					ssh.updateDisplay();
//cfDbg('lf',1)
				}
				// Left arrow
				else if(p==8) {
					ssh.x--;
					if(ssh.x<0){
						ssh.x=ssh.w-1;
						ssh.y=Math.max(ssh.y-1,0);
					}
					ssh.moveCursor();
				}
				// else if(p==7){} // Bell
			}
			else cfDbg('?:'+t+'=>'+p+'/',1)
		}
		// Redraw display
		ssh.updateDisplay();
		ssh.moveCursor();
	},
	/**
	 * Set a character at position x,y, with format
	 * @param string chr: character,
	 * @param int x: x position (column),
	 * @param int y: y position (line),
	 * @param array format: [a,b,c], with 0<= a < 9, 29 < b < 38, 39 < c < 48 (see ssh.format)
	 */
	'setChar':function(chr,x,y,format){
		//cfDbg(x+'x'+y+'/',1)
		if(format && format.length==3 && format[0]==0 && format[1]==0 && format[2]==0) format=0;
		ssh.d[y][x]=((format)?[chr,format]:[chr]);
		ssh.lineMod[y]=1; // Set line as modified for re-display
	},

	/**
	 * Move cursor node at position
	 * @param int x: x position (current position if omitted)
	 * @param int y: y position (current position if omitted)
	 */
	'moveCursor':function(x,y){
		if(x==undefined) x=ssh.x;
		if(y==undefined) y=ssh.y;
		dgi('sshCmd').style.left=(x*ssh.dx)+'px';
		dgi('sshCmd').style.top=(y*ssh.dy)+'px';
	},

	/**
	 * Return HTML formated line
	 * @param int lineNb: requested line
	 */
	'htmlLine':function(lineNb){
		var l='',cell,format,f,c;
		//l='<div style="position:absolute;right:20">'+lineNb+'</div>';

		for(o=0;o<ssh.w;o++){
			cell=ssh.d[lineNb][o];
			try{cell.length} catch(e){
				alert(ssh.d[lineNb].length);alert('line:'+lineNb+' col:'+o);alert(ssh.w+'x'+ssh.h+'/'+ssh.nbLines)
			}
			c=cell[0]; if(c==' ') c='&nbsp;';
			if(cell.length==1) {
				l+=c; // No embedded format: just insert char
			}
			else{
				//alert('cell :)'+cell[1])
				format=cell[1];
				f='';
				if(typeof format=='object') {
					if(format.length!=undefined){
						for(i=0;i<format.length;i++){
							if(ssh.formats[format[i]]) f+=ssh.formats[format[i]]+';'
						}
					}
					// WA: format is not an array
					else{
						for(i=0;i<4;i++) {
							if(format[i]!=undefined && ssh.formats[format[i]]) f+=ssh.formats[format[i]]+';'
						}
					}
				}
				//if(f) alert('<span style="'+f+'">'+c+'</span>')
				if(f) l+='<span style="'+f+'">'+c+'</span>'; else l+=c;
			}
		}
		//cfDbg(l.replace(/</gi,'&lt;'),1)
		return l;
	},
	/**
	 * Makes a carriage return & line feed
	 */
	'LF':function(){
		var i,o,nl;
		ssh.y++; // LF
		// If a new line needs to be created
		if(ssh.y>ssh.nbLines-1){
			ssh.addLine();
		}
	},

	/**
	 * Append new line
	 */
	'addLine':function(){
		// Lines buffer not yet filled: create a new line
		if(ssh.nbLines<ssh.h){
			nl=D.createElement('DIV');
			nl.className='line';
			nl.id='line'+ssh.nbLines;
			ssh.div.appendChild(nl);
			ssh.lineMod[ssh.nbLines]=1;
			ssh.d[ssh.nbLines]={};
			for(o=0;o<ssh.w;o++) ssh.setChar(' ',o,ssh.nbLines,0);
			ssh.nbLines++;
		}
		// Else, shift all lines one step up
		else{
			for(i=0;i<ssh.h-1;i++) {
				dgi('line'+i).innerHTML=dgi('line'+(i+1)).innerHTML;
//dgi('line'+(i+1)).innerHTML='.'+ssh.htmlLine(i+1);
				//ssh.d[i]=wl.objectClone(ssh.d[i+1])
				ssh.d[i]=ssh.d[i+1];
				ssh.lineMod[i]=ssh.lineMod[i+1];
			}
			ssh.y--;
			// Empty new line
			dgi('line'+(ssh.h-1)).innerHTML='';
			ssh.d[ssh.h-1]={};
			for(o=0;o<ssh.w;o++) ssh.setChar(' ',o,ssh.h-1,0);
		}
	},

	/**
	 * Update display with modified lines
	 * @desc bool force: true to redraw even if line is not modified
	 */
	'updateDisplay':function(force){
		var line,l,mod=0;
		for(line=0;line<ssh.nbLines;line++) if(ssh.lineMod[line]||force) {
			ssh.lineMod[line]=0;
			dgi('line'+line).innerHTML=ssh.htmlLine(line);
			mod++;
		}

		if(mod) ssh.div.scrollTop=ssh.div.scrollHeight;
	},

	// Key down: only process tab
	'keyDown':function(elt,e){
		if(!e) e=window.event;
		var kc=wl.eventKC(e);
		if(kc==9) {
			ssh.keyAddSeq('['+kc+']');
			setTimeout(function(){dgi('sshCmd').focus()},10);
		}
		return false;
	},

	/**
	 * onkeyup: process pressed key
	 * @param elt: textarea node
	 * @param e: event
	 */
	'keyUp':function(elt,e){
		if(!e) e=window.event;
		var kc=wl.eventKC(e);
		var ctrl=e.ctrlKey;

		// Special keys
		if(0 < kc && kc < 49 && kc!=32 && kc!=48) {
			if(kc==13||kc==10||kc==8||kc==37||kc==38||kc==39||kc==40) ssh.keyAddSeq('['+kc+']');
		}
		// Forward control commands
		else if(ctrl && kc>64 && kc<91) ssh.keyAddSeq('[c'+(kc-64)+']');

		// viewable char
		else if (elt.value) {
			var txt2='',txt=elt.value.replace(/\[/g,'/[91]/').replace(/\//g,'/[47]/');
			txt=txt.replace(/\/\[47\]\/\[91\]\/\[47\]\//g,'/[91]/')
			txt=txt.replace(/\&/g,'/[c38]/'); // Escape "&"
			for(var i=0;i<txt.length;i++) if(txt.charCodeAt(i)>=32) txt2+=txt.substr(i,1)
			ssh.keyAddSeq(txt2);
		}
		elt.value='';
		return false;
	},

	/**
	 * Add a key sequence to buffer and send if previous request is finished
	 * @param string keySeq: encoded keys sequence
	 */
	'keyAddSeq':function(keySeq){
//cfDbg('<'+keySeq+'>',1)
		ssh.keyBuffer+=((ssh.keyBuffer)?'/':'')+keySeq;
		ssh.keySend();
	},

	/**
	 * Send buffered key sequence if previous request is finished (and buffer is not empty)
	 */
	'keySend':function(){
		if(ssh.keyReady && ssh.keyBuffer.length) {
//			cfDbg('S'+ssh.keyBuffer,1)
			// AES encrypt send data
			if(ssh.JSCipher) ssh.keyBuffer=ssh.symEncrypt(ssh.keyBuffer)
			wl.asr.send('sshSendCommand='+ssh.keyBuffer);
			ssh.keyBuffer='';
			ssh.keyReady=0;
		}
	},

	/**
	 * Called by php script when done receiving key sequence: just indicate that another key sequence may be sent, and do send if buffer is not empty
	 */
	'keyReceived':function(){
		ssh.keyReady=1;
		ssh.keySend();
	},

	/**
	 * Window resized: adapt terminal width
	 */
	'winResized':function(){
		var w=winMe.getInnerWidth(),h=winMe.getInnerHeight();
		var prevW=ssh.w,i;

		ssh.w=Math.max(20,Math.floor(w/ssh.dx));
		ssh.h=Math.max(ssh.h,Math.floor(h/ssh.dy));
		//alert('resize '+ssh.nbLines+' lines from '+prevW+' to '+ssh.w)
		// Enlarged terminal: fill lines with spaces
		if(ssh.w>prevW){
			for(i=0;i<ssh.nbLines;i++){
				for(o=prevW;o<ssh.w;o++) ssh.d[i][o]=['&nbsp;'];
			}
		}
	},

	/**
	 * Re-focus on textarea on key press
	 */
	'refocus':function(){
		if(ssh.inputActive) dgi('sshCmd').focus();
	},

	/**
	 * Update connection status
	 * @param string status: new status HTML
	 */
	'updateStatus':function(status){
		$('status').innerHTML=status;
	},

	/**
	 * Fade-in login form and focus on input field
	 */
	'loginShowForm':function(){
		$("loginFormDiv").e.fadeIn();
		setTimeout(function(){if(dgi('username')) dgi('username').focus(); else dgi('password').focus()},100);
	},

	// Submit login form
	'loginSubmit':function(){
		var p=$('password').value,u='';
		if(dgi('username')) {
			if(!u) {
				$('username').focus();
				return;
			}
			u=dgi('username').value;
		}

		if(ssh.JSCipher){
			p=ssh.symEncrypt(p);
			if(u) u=ssh.symEncrypt(u);
		}
		else{
			p=Base64.encode(p);
			if(u) u=Base64.encode(u);
		}
		$("loginFormDiv").e.fadeOut();
		wl.asr.send({'login':1,'username':u,'password':p});
	},

	/**
	 * Init symetric crypto by generating a random key and sending it RSA-encoded
	 */
	'JSCipherInit':function(){
		var i;
		ssh.symKey='';
		ssh.haltSeq='';
		for(i=0;i<ssh.symKeyLength/8;i++) ssh.symKey+=String.fromCharCode(56+Math.floor(Math.random()*64));
		for(i=0;i<4;i++) ssh.haltSeq+=String.fromCharCode(Math.floor(Math.random()*255));
		// Encode
ssh.symKey="1234567890"
ssh.haltSeq="0000"
		RSACrypt(Base64.encode(ssh.haltSeq+ssh.symKey),ssh.RSACrypted,$('rsaOut'));
	},

	/**
	 * Send symetric key to server
	 */
	'RSACrypted':function(str){
		wl.asr.send({'symKey':str});
	},

	/**
	 * Symetric key received by server
	 */
	'symKeyReceived':function(str){
		$('rsaOut').innerHTML=str;
		// Start pulling data
		if(ssh.loginOK) ssh.pull();
		else ssh.loginShowForm();
	},

	/**
	 * AES encrypt content using sym key
	 */
	'symEncrypt':function(clearText){
		// If text is too short, add a random sequence, initiated by haltSeq
		//if(1||clearText.length<7+Math.floor(Math.random()*5)) {
			clearText+=ssh.haltSeq;
			var i=0;
			while(clearText.length%(ssh.symKeyLength/8) || i==0) {
				clearText+=String.fromCharCode(Math.floor(Math.random()*255));
				i++;
			}
		//}
		// AES encrypt
		return Aes.Ctr.encrypt(Base64.encode(clearText), ssh.symKey, ssh.symKeyLength);
	},

	/**
	 * Encrypt content using sym key
	 */
	'symDecrypt':function(encryptedText){
		var dec=Aes.Ctr.decrypt(encryptedText, ssh.symKey, ssh.symKeyLength);
		return dec;
	},

	/**
	 * @desc Initialization
	 */
	'init':function (){
//cfDbgToggle();
		var line,col;
		ssh.div=$('sshOut');
		if(W.sshWidth) ssh.w=W.sshWidth;
		if(W.sshHeight) ssh.h=W.sshHeight;
		ssh.LF(); ssh.y=0;
		// Set character width & height for cursor absolute positionning
		ssh.dx=dgi('templateChar').offsetWidth;
		ssh.dy=dgi('templateChar').offsetHeight;
		$('templateChar').e.remove();
		// Build lines array
		for(line=0;line<ssh.h;line++){
			ssh.d[line]={}
			ssh.lineMod[line]=0;
			for(col=0;col<ssh.w;col++) ssh.d[line][col]=[' '];
		}
		ssh.winResized();
		ssh.setChar('$',0,0);
		ssh.setChar(' ',1,0);
		ssh.x=2;
		ssh.updateDisplay();
		ssh.moveCursor();
		dgi('sshCmd').focus();
		connect(W,'keydown',ssh.refocus)

		// If javascript ciphering, generate key and send it RSA encoded to server
		if(ssh.JSCipher) ssh.JSCipherInit();

		// Else just start pulling data
		else ssh.pull();
	}

}
function winResized(){ssh.winResized()}