<?php


/**
 * @desc Return data for general block
 *
 * @return array(title,content,action)
 */
function uiConfigBlockGeneral(){
	$title=outImage(outIcon('appIcon32'),false,false,'vertical-align:top;margin-right:1em').cfCaption('configApplication');
	$content='<div style="position:absolute;width:100%;top:50%;margin-top:-1em;left:0">';
	$content.=cfCaption('configApplicationStartMode').', '.cfCaption('configMinimizeToTray').', '.cfCaption('configConfirmExit').'...';
	$content.='</div>';
	$content.=outImage(outIcon('UI/configLeft'),false,false,'position:absolute;left:10px;bottom:10px');
	$action="showFrame('general',-1,0)";

	return array('title'=>$title,'content'=>$content,'action'=>$action);
}



/**
 * @desc general parameters configuration items
 *
 */
function uiConfigFrameGeneral(){
	global $resourceData;

	echo outDivframe('frame1');
	?>
	<div class="frame1Header"><?php
	uiConfigAdvancedConfigButton('general');
	echo outImage(outIcon('appIcon32'),false,false,'margin-right:0.5em;vertical-align:middle').cfCaption('configApplication');
	// Save configuration button
	echo '<span id="configSaveBt" style="cursor:pointer;margin-left:1em">'.outImageIcon('save').outImageIcon('down').'</span>';
	?></div>
	<?php
	echo outConfigSeparator();

	// Weezo start mode
	if(WEnv::host()->isWindows()){
		if(cfUACPresent()) echo outImageIcon('uac');
		rcProcessData('startWithWindows',dataList,false,
			array(true,false,'service'),
			array(
				array(false,cfCaption('configApplicationStartMode')),
				array(
					array('true',cfCaption('configStartWindows')),
					array('service',cfCaption('configStartService')),
					array('false',cfCaption('configStartManual'))
				),
				false),
			false);

		// Launch Weezo with admin privileges (for service mode)
		if(WEnv::config()->getVar('OSMajorVersion')>=6){
			echo '<span id="launchWithAdminRightsBlock" style="margin-left:3em'.(($resourceData['startWithWindows']=='service')?'':';visibility:hidden').'">';
			rcProcessData('launchWithAdminRights',dataBoolean,false,false,cfCaption('launchWithAdminRights'));
			echo '</span>';
		}
		echo '<br><br>';
	}
	// Minimize application at startup
	rcProcessData('startMinimized',dataBoolean,true,false,cfCaption('configStartMinimized'),false,false);

	// Reduce to system tray at startup
	if(WEnv::host()->hasFeature('tray')) rcProcessData('reduceToTray',dataBoolean,true,false,cfCaption('configMinimizeToTray'),false,false);

	// Prompt user before quitting application
	rcProcessData('promptBeforeExit',dataBoolean,true,false,cfCaption('configConfirmExit'),false,false);

	// Prevent computer from going to sleep
	if(WEnv::host()->hasFeature('preventSleepMode')){
		echo outImageIcon('noSleep');
		rcProcessData('preventHostFromEnteringSleepMode',dataBoolean,true,false,cfCaption('preventSleepMode'),false,false);
	}

	echo '<br style="clear:all">';
	echo '<br>';

	/***************************************************************************************************************************
	 *  Advanced config section
    ***************************************************************************************************************************/
	echo uiConfigAdvancedFrameHeader('general');

		/**
		 * Application main directories
		 */
		if(!WEnv::host()->isOSX()){
			echo outDivFrame('frame2',false,'position:absolute;right:15px;width:300px');
			echo '<div class="frame2Header">'.outImage(outIcon('folder'),false,false,'vertical-align:middle;margin-right:1em').cfcaption('genDirectories').'</div>';
			echo outTableTransparent('frame2','table-layout:fixed');
			echo '<tr><td style="width:140px"><b>'.APPLICATION_NAME.' (exe)'.cfCaption('genSeparator').' </b></td><td> '.uiConfigDirLink('bin').'</td></tr>';
			echo '<tr><td><b>Apache'.cfCaption('genSeparator').' </b></td><td> '.uiConfigDirLink('apache').'</td></tr>';
			echo '<tr><td><b>PHP'.cfCaption('genSeparator').' </b></td><td> '.uiConfigDirLink('php').'</td></tr>';
			echo '</td></tr>';
			echo '<tr><td><b>'.cfCaption('genData').cfCaption('genSeparator').' </b></td><td> '.uiConfigDirLink('data').'</td></tr>';
			echo '<tr><td><b>'.('www').cfCaption('genSeparator').' </b></td><td> '.uiConfigDirLink('www').'</td></tr>';
			echo '<tr><td><b>'.cfCaption('genWallpaper').cfCaption('genSeparator').' </b></td><td> '.uiConfigDirLink('wallpapers').'</td></tr>';
			echo '</table>';
			echo '</div>';
		}

		if(WEnv::host()->isWindows()){
			// Open Windows XP firewall
			echo outImageIcon('firewall');
			rcProcessData('configureWindowsXPFirewall',dataBoolean, true, false, cfCaption('acConfigureWindowsXPFirewall'));

			// Close Windows XP firewall and unmap ports on exit
			echo outImageIcon('firewallOff');
			rcProcessData('closeFirewallAndUPnPAtShutdown',dataBoolean, false, false, cfCaption('closeFirewallAndUPnPAtShutdown'),true);
		}

		// context menu integration (get value from registery)
		if(WEnv::host()->hasFeature('contextMenuIntegration')){
			if(!cfIsAsync()) $resourceData['contextMenuIntegration']=uiConfigCMisSet();

			echo outImageIcon('contextMenu');
			rcProcessData('contextMenuIntegration',dataBoolean, true, false, cfCaption('IntegrateIntoShell'),false);
			if(cfUACPresent()) echo outImageIcon('uac');
			echo '<br>';
		}

		// Single click on icon to restore from tray
		if(WEnv::host()->isWindows()){
			echo outImageIcon('click');
			rcProcessData('traySingleClickRestore',dataBoolean, true, false, cfCaption('acTraySingleClickRestore'));
		}

		// Show a popup when a contact is detected as online
		echo outImageIcon('info2');
		rcProcessData('messageOnContactOnline',dataBoolean, true, false, cfCaption('acMessageOnContactOnline'));

		// Proxy
		echo '<br><br>';
		echo outDivFrame('frame3');
		echo '<div class="frame3Header">'.(cfCaption('acProxy')).'</div>';
		rcProcessData('proxyEnabled',dataBoolean,false,false,cfCaption('acProxyEnabled'),false);
		echo '<div id="configProxyFrame" style="'.(($resourceData['proxyEnabled'])?'':outCssOpacity(20)).'">';
		rcProcessData('proxyIP',dataText,'0.0.0.0',false,array('IP / URL ',10),false,false);
		rcProcessData('proxyPort',dataNumeric,8080,array(0,65535),array('&nbsp;&nbsp;&nbsp;'.cfCaption('genPort'),3),false,false);
		echo '&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;';
		rcProcessData('proxyUsername',dataText,'',false,array(cfCaption('userName'),10),false);
		echo '&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;';
		rcProcessData('proxyPassword',dataPassword,'',false,array(cfCaption('genPassword'),10));
		echo '</div></div>';
		echo '<br>';

		// Forced LAN IP
		rcProcessData('LANIPForced',dataText,'',rcConstraintIP(),array(cfCaption('acLANIPForced',cfGGetVar('LANIPComputed')),10),1, false,array('apply'=>1));
		echo '<br>';

		echo '</div>';// Fade frame end
		echo '</div>';// Advanced config end
	?>
	</div>
	<?php
}
