<?php
/**
 * Redirector & resizer for cross domain popups in user interface:
 * The UI command mechanism beeing quite limited, it can't request a size for a web browser popup, and can neither request a non-local URL
 * @param GET url: url encoded (external) url
 * @param GET title: popup title (default: use url)
 * @param GET width: popup width (default 300)
 * @param GET heigh: popup height (default 200)
 *
 * PHP version 5
 *
 * LICENSE: This source file is subject to version 3.0 of the PHP license
 * that is available through the world-wide-web at the following URI:
 * http://www.php.net/license/3_0.txt.  If you did not receive a copy of
 * the PHP License and are unable to obtain it through the web, please
 * send a note to license@php.net so we can mail you a copy immediately.
 *
 * @category   NA
 * @package    NA
 * @author     Nicolas Bruley / Peer 2 World <contact@weezo.net>
 * @copyright  2005-2009 Nicolas Bruley / Peer 2 World
 * @license    http://www.php.net/license/3_0.txt  PHP License 3.0
 * @version    CVS: $Id:$
 * @link       http://www.weezo.net
 * @since      File available since Release 2.2.0
 */


if(!cfIsInApp() || !isset($_GET['url'])) die();

$url=$_GET['url'];

// Qt version WA: url is not decoded by app so it needs to be decoded here
if(substr($url,0,5)=='http%' || substr($url,0,6)=='https%') $url=urldecode($url);

// Set window title and size
$title=@$_GET['title']; if(!$title) $title=$url;
$width=@$_GET['width']; if(!$width) $width=300;
$height=@$_GET['height']; if(!$height) $height=200;

cfInsertHEAD(true,array('size'=>$width.'x'.$height,'title'=>$title));
?>
<body>
<script type="text/javascript">
function redir(){document.location.href="<?php echo $url;?>"}
setTimeout(redir,1)
</script>
</body>