<?php
/**
 * Administration configuration file *** DEPRECATED ***
 *
 * Configuration of administration resource
 * this script is included by /res/administration/std/resourceConfig.php
 * this script should never be directly called.
 * this script can only be accessed in "application environment"
 *
 * resourceConfig.php sets 2 variables :
 * $resourceData (array) which contains resource parameters
 * $_ENV['configurationEnvironment'] which indicates if resourceConfig.php has been called from browser ('browser')
 * or from application's embeded browser ('application')
 *
 * PHP version 5
 *
 * LICENSE: This source file is subject to version 3.0 of the PHP license
 * that is available through the world-wide-web at the following URI:
 * http://www.php.net/license/3_0.txt.  If you did not receive a copy of
 * the PHP License and are unable to obtain it through the web, please
 * send a note to license@php.net so we can mail you a copy immediately.
 *
 * @category   NA
 * @package    NA
 * @author     Nicolas Bruley / Peer 2 World <contact@weezo.net>
 * @copyright  2005-2009 Nicolas Bruley / Peer 2 World
 * @license    http://www.php.net/license/3_0.txt  PHP License 3.0
 * @version    CVS: $Id:$
 * @link       http://www.weezo.net
 * @since      File available since Release 1.0.5
 */
die();
/**
 * Format variable name into almost readable caption
 *
 * @param string $txt : variable name
 * @return string
 */
function capt($txt){
	$out='';
	for($i=0;$i<strlen($txt);$i++){
		if($i==0) $out.=strtoupper($txt[$i]);
		elseif($txt[$i]==strtoupper($txt[$i]) && (($txt[$i-1]!=strtoupper($txt[$i-1])) || ($i<strlen($txt)-1 && $txt[$i+1]!=strtoupper($txt[$i+1])))) $out.=' '.$txt[$i];
		else $out.=$txt[$i];
	}
	return $out;
}


/**
 * @desc format variable description
 *
 * @param string $title
 * @return string
 */
function dataTitle($title){
	return '<br/><b>'.$title."</b><br>\n";
}


/**
 * @desc Echo code for an icon indicating server restart is needed
 *
 */
function acServerRestartIcon(){
	echo outImage(outIcon('serverRestart'));
}



//#############################################################################################################
// Verify access right (complementary of controls realized in security.php
//#############################################################################################################
if($_SERVER['REMOTE_ADDR']!='127.0.0.1'){
	cfLog('administration : unauthorized access attempt by '.$_SERVER['REMOTE_ADDR'], LOG_DBG);
	outDisplayErrorPage(cfcaption('errorRemoteAdministrationNotAuthorized')); // If no access right, display error page and exit
}


// Read data
$resourceData=cfParse_ini_file(cfAppDataDir().'/general.ini');

/*
 ***************************************************************************************************************************
 * Process POST actions
 ***************************************************************************************************************************
 */
if(isset($_POST['commandSent'])){

	switch ($_POST['commandSent']) {
		// Delete IP/password ban file
		case 'resetPasswordCheckBanPeriod':
			@unlink(cfAppDataDir().'/connectionAttempts.txt');
			break;
		case 'phpinfo';
			ob_start();
			phpinfo();
			$out=ob_get_clean();
			echo str_replace('</head>',cfUIMeta('title','phpinfo()',true)."\n</head>",$out);
			exit;
	}
	// Open local folder
	if(cfCmpLeft($_POST['commandSent'],'shellOpenFolder:')){
		list($foo,$folder)=explode(':',$_POST['commandSent']);
		cfExecFork('explorer','SW_SHOWNORMAL','"'.acDirLink($folder,true).'"');
		cfAsyncHeader();
		die(cfAsyncFooter());
	}
}


/*
 ***************************************************************************************************************************
 * Process GET actions
 ***************************************************************************************************************************
 */
if(isset($_GET['commandSent'])){
	// Backup configuration
	if($_GET['commandSent']=='saveconfig'){
		require(cfAppDocRoot().'/local/configBackup.php');
		configBackupSend();
	}
}


/*
 ***************************************************************************************************************************
 * Display configuration form
 ***************************************************************************************************************************
 */

// Insert Javascript function needed for save button activation, and <form> with hidden fields.
rcInsertScriptAndForm();



// OVERFLOW DIV
?>
<div id="scrollDiv" style="position:relative;height:80%;overflow:auto;display:block;margin-bottom:0.5em;background:none" class="frame2">
<?php
/**
 * Configuration backup / restore
 */
echo outDivFrame('frame2');
echo '<div class="frame2Header">'.cfCaption('mainConfigButton').'</div>';
echo outButton('',"javascript:wl.goURL('&commandSent=saveconfig&noHead=1')",outIcon('configSave')).'<span style="margin-left:0.5em;position:relative;top:-5px">'.cfCaption('saveConfiguration').'</span><br>';
echo outButton('',"javascript:wl.UICommand('restoreconfig')",outIcon('configRestore')).'<span style="margin-left:0.5em;position:relative;top:-5px">'.cfCaption('restoreConfiguration').'</span>';
echo '</div>';

/**
 * Development
 */
if(isset($resourceData['development']) && $resourceData['development']){
	echo outDivFrame('frame2');
	rcProcessData('UIDebug',dataBoolean,false,false,'User Interface debug',true,false);
	rcProcessData('PHPDebug',dataBoolean,false,false,'PHP debug',true,false);

	echo '</div>';
}

/**
 * Weezo directories
 */
echo '<a href="#" name="directories_"></a>';


/**
 * SERVER PARAMETERS
 */
echo '<a href="#" name="server_"></a>';
echo outDivFrame('frame2',false,'display:none');
echo '<div class="frame2Header">'.outImage(outIcon('apache'),false,false,'vertical-align:middle;margin-right:1em').cfcaption('acServerSettings').'</div>';
echo ''.cfcaption('acServerSettingsNote').'';
acServerRestartIcon();
echo '<br>';

rcProcessData('defaultServerState',dataList,'web',array('web','local'),array(
array(false,cfCaption('configServerStartMode')),array(
array('web',cfCaption('configServerStartModeWeb')),
array('local',cfCaption('configServerStartModeLocal'))
),false),true);
echo '<br>';

// Alternate server port
rcProcessData('alternateServerPort',dataNumeric,0,array(0,65535),array('<b>'.cfCaption('alternatePort').'</b> (0-65535)',3,' '),false,false);

// Alternate server port SSL
rcProcessData('alternateServerPortSSL',dataBoolean,((cfGGetVar('alternateServerPort')==443)?false:true),false,'<b>SSL</b>',false);

// IP restrictions
echo '&nbsp;&nbsp;&nbsp;&nbsp;'.outButton(cfCaption('configIPFilter'),'javascript:IPFilterSet()',outIcon((cfIPFilterIsset())?'stop':'ahead')).'<br><br>';

// Pages compression
rcProcessData('webPagesCompressionLevel',dataNumeric, 0, array(0,9), array(cfCaption('acWebPagesCompressionLevel'),1), true, false);
echo '<br><br>';

// SSL
echo outDivFrame('frame3');
echo '<div class="frame3Header">SSL</div>';

// Regenerate SSL certificate
echo '<br>'.outButton(cfCaption('configGenerateCertificate'),'javascript:SSLCertificateRegen()',outIcon('certificate')).'<br><br>';

// Generate SSL certificate according to server's IP
rcProcessData('useIPForSSLCertificate',dataBoolean,true,false,cfCaption('useIPForSSLCertificate'));
echo '</div>';

// Cipher password on non-SSL connection
rcProcessData('encryptPassword',dataBoolean,true,false,cfCaption('configEncryptPasswords'));

// Proxy
echo '<br><br>';
echo outDivFrame('frame3');
echo '<div class="frame3Header">'.(cfCaption('acProxy')).'</div>';
rcProcessData('proxyEnabled',dataBoolean,false,false,cfCaption('acProxyEnabled'),true,false);
rcProcessData('proxyIP',dataText,'0.0.0.0',false,array('IP',10),false,false);
rcProcessData('proxyPort',dataNumeric,8080,array(0,65535),array('&nbsp;&nbsp;&nbsp;'.cfCaption('genPort'),3),true,false);
rcProcessData('proxyUsername',dataText,'',false,array(cfCaption('userName'),10),true,false);
rcProcessData('proxyPassword',dataText,'',false,array(cfCaption('genPassword'),10),true,false);
echo '</div>';

// Forced LAN IP
echo '<br>';
rcProcessData('LANIPForced',dataText, '', false, array(cfCaption('acLANIPForced',cfGGetVar('LANIPComputed')),10),1, false);
echo '<br>';

// HTTPD compatibility mode
rcProcessData('httpdCompatibilityMode',dataBoolean, false, false, cfCaption('acHttpdCompatibilityMode'),true, false);
echo '<br>';

// Server crash monitoring by Weezo
rcProcessData('serverCrashMonitor',dataBoolean, true, false, cfCaption('acServerCrashMonitor'), true, false);

// Weezo crash monitoring by server
rcProcessData('weezoCrashMonitor',dataBoolean, true, false, cfCaption('acWeezoCrashMonitor'), true, false);

// File / memory : display only if sessionHandler was memory
if(isset($resourceData['sessionHandler']) && $resourceData['sessionHandler']=='memory'){
	echo dataTitle('Apache session handler</b><br>"Memory" session handling should be more efficient (faster and less disk access) but is quite unstable and might cause unexpected disconnections<b>');
	rcProcessData('sessionHandler',dataList,'file',array('file','memory'),array(
	array(false,cfCaption('sessionHandler')),array(
	array('file','file '),
	array('memory','memory')
	),false),true);
}

// OpCode Caching (APC/XCache)
echo '<br>';
rcProcessData('serverOpCodeCache',dataList,'XCache',array('XCache','APC','no'),array(
array(false,'OpCode Cache'),array(
array('XCache','XCache'),
array('APC','APC'),
array('no',cfCaption('genDisabled'))
),false),false);
if(extension_loaded('apc')) echo outButton(cfCaption('genStats'),'javascript:apcStats()',outIcon('stats'),false,'apcStatsBt');
else						echo outButtonDisabled(cfCaption('genStats'));
echo '<br><center><iframe id="apcStats" style="width:100%;display:none;height:1px" class="frame3"></iframe></center><br>';

// Logs
rcProcessData('phpLogErrors',dataBoolean, true, false, cfCaption('acPhpLogErrors'),false, false);
if($resourceData['phpLogErrors'] && file_exists(cfAppDocRoot().'/'.PHP_ERRORS_LOG_FILE)) echo outButton(cfCaption('genSend'),'/local/submitErrorReport.php',false,false,false,'style="vertical-align:middle"');
echo '<br>';
rcProcessData('phpHideErrors',dataBoolean, false, false, cfCaption('acPhpHideErrors'), true, false);
echo '<center>'.outButton('PHP - '.cfCaption('genInfos').' - phpinfo()',"javascript:dgn('commandSent').value='phpinfo';dgn('configForm').submit();").'</center>';

echo '<br>';

rcProcessData('turnOffApacheAtExit',dataBoolean, false, false, cfcaption('acTurnOffApacheAtExit'), true, false);

echo '<br><br><b>'.cfCaption('activityLogs').'</b><br>';
rcProcessData('apacheAccessLog',dataBoolean, false, false, HTTPD_ACCESS_LOG_FILE, true, false);
rcProcessData('apacheErrorLog',dataBoolean, false, false, HTTPD_ERRORS_LOG_FILE, true, false);
rcProcessData('historyLogViewedContent',dataBoolean, false, false, cfCaption('historyLogContent'), false, false);
rcProcessData('historyLogViewedContentDays',dataNumeric, 365, array(0,999999), array(1,cfCaption('genDays')), true, false);
echo '</div><br/>';




/**
 * MISC SETTINGS
 */
echo '<a href="#" name="misc_"></a>';
echo outDivFrame('frame2');
echo '<div class="frame2Header">'.outImage(outIcon('advancedConfig'),false,false,'vertical-align:middle;margin-right:1em').cfCaption('acMiscSettings').'</div>';

echo '<br>';

// Show splash screen at startup (non-reduced startup only)
//xxx rcProcessData('showSplashScreen',dataBoolean, true, false, cfCaption('acShowSplashScreen'), true, false);

// Let user select pages theme
rcProcessData('allowUserThemeChange',dataBoolean, true, false, cfCaption('configUserSelectTheme'), true, false);

echo '<br>';

// Drag & launch parameters
rcProcessData('dragNLaunchThreshold',dataNumeric,100,array(0,1000),array(cfCaption('acDragNLaunchThreshold'),1,''),true,false);
rcProcessData('dragNLaunchFriction',dataNumeric,0.005,array(0,1),array(cfCaption('acDragNLaunchFriction'),1,''),true,false);
echo '<br>';

// UI Fade effect
rcProcessData('UIFadeEffect',dataBoolean, true, false, cfCaption('acUIFadeEffect'), true, false);
rcProcessData('mainFormFadeAlpha',dataNumeric,200,array(0,255),array(cfCaption('acMainFormFadeAlpha'),1,''),true,false);

echo '<br>';


/*
echo '<br><b>'.outImageIcon('new').cfCaption('startCheckForUpdates').' &nbsp;</b>';
rcProcessData('checkUpdates',dataBoolean, true, false, '&nbsp;',true, false);

// Beta versions
echo outImageIcon('beta');
rcProcessData('installBeta',dataBoolean, false, false,cfCaption('configInstallBetas'), true, false);


rcProcessData('updateApplication',dataList,'confirm',array('confirm','auto'),array(
array(false,cfCaption('acUpdateApplication')),array(
array('confirm',cfCaption('genConfirm')),
array('auto',cfCaption('genAutomatic'))
),false),true);
*/
echo '</div>';
echo '</form>';
echo '</div>';
// Save / cancel buttons
echo rcButtonSaveCancel(true);
?>
<script type="text/javascript">
function openFolder(name){
	wl.asr.send({'commandSent':'shellOpenFolder:'+name})
}
function dataChanged(dataName,dataValue){

}
function dataInitForm(){
}
dataInitForm();

function apcStats(){
	dgi('apcStats').src="/local/apc.php";
	dgi('apcStats').style.display='';
	wl.fadeStyle('scrollDiv','scrollTop',dgi('apcStatsBt').offsetTop+160,'exponential');
	wl.fadeStyle('apcStats','width',100,'exponential');
	wl.fadeStyle('apcStats','height',450,'exponential');

	wl.UICommand('fadeSize','800x600')
}

function IPFilterSet(){wl.UICommand('close:IPFilterSet')}
function SSLCertificateRegen(){wl.UICommand('close:SSLCertificateRegen')}
wl.UICommand('fadeSize','640x600');
</script>
<?php
/**
 * Commit changes
 */

// Save to general.ini file
cfWriteIniFile($resourceData,cfAppDataDir().'/general.ini',true);

// Apply (some) changes by reseting in-memory configuration
@cfMUnsetVar('weezoGeneral');

if(isset($_POST['commandSent']) && $_POST['commandSent']=='modify'){
?>
<script type="text/javascript">
	wl.UICommand("reloadGeneral");
</script>
<?php
}
if(isset($_GET['cancel'])) {
?>
<script type="text/javascript">
	wl.UICommand('close');
</script>
<?php
}

?>