<?php
/**
 * Contacts view and modification script
 *
 * this script is included by index.php and shouldn't be directly called
 *
 * PHP version 5
 *
 * LICENSE: This source file is subject to version 3.0 of the PHP license
 * that is available through the world-wide-web at the following URI:
 * http://www.php.net/license/3_0.txt.  If you did not receive a copy of
 * the PHP License and are unable to obtain it through the web, please
 * send a note to license@php.net so we can mail you a copy immediately.
 *
 * @category   NA
 * @package    NA
 * @author     Nicolas Bruley / Peer 2 World <contact@weezo.net>
 * @copyright  2005-2009 Nicolas Bruley / Peer 2 World
 * @license    http://www.php.net/license/3_0.txt  PHP License 3.0
 * @version    CVS: $Id:$
 * @link       http://www.weezo.net
 * @since      File available since Release 1.0.0
 */


/*
 * Verify access rights
*/
if($_SERVER['REMOTE_ADDR']!='127.0.0.1'){
	if(cfUGetVar('administrator')!=true ||  !cfGGetVar('remoteAdministrationAuthorized')) outDisplayErrorPage(cfcaption('errorRemoteAdministrationNotAuthorized'));
}

// Read contacts file
$contacts=cfParse_ini_file(cfAppDataDir().FILE_CONTACTS,true,false); if(!$contacts) $contacts=array();

/*
 ***************************************************************************************************************************
 * Process POST commands
 ***************************************************************************************************************************
 */

// New contact
if(isset($_POST['name']) && isset($_POST['type']) && ($_POST['type']=='reg' || isset($_POST['url'])) && (strlen($_POST['name'])>4 && strlen($_POST['name'])<16)){
	if(!isset($contacts['name']) || cfRGetVar('advancedAdministration')){
		$contacts[$_POST['name']]=array();
		$contacts[$_POST['name']]['type']=$_POST['type'];
		if(isset($_POST['notes'])) $contacts[$_POST['name']]['notes']=cfUTF8Decode($_POST['notes'],true,true,false);
		if(isset($_POST['url']) && $_POST['type']=='unreg') $contacts[$_POST['name']]['url']=$_POST['url'];
		$contacts[$_POST['name']]['online']=false;

		// Save file and inform application
		cfWriteIniFile($contacts, cfAppDataDir().FILE_CONTACTS, true); cfServerSendCommand('refreshContacts');
	}
}
elseif (isset($_POST['data1']) && isset($_POST['data3']) && isset($contacts[$_POST['data1']])){
	// Delete contact
	if($_POST['data3']=='deleteContact') unset($contacts[$_POST['data1']]);
	// Modify notes
	if($_POST['data3']=='modifyContact' && isset($_POST['data2'])) $contacts[$_POST['data1']]['notes']=cfUTF8Decode($_POST['data2']);
	// Save file and inform application
	cfWriteIniFile($contacts, cfAppDataDir().FILE_CONTACTS, true); cfServerSendCommand('refreshContacts');
}

// Insert form
outInsertStandardComForm($_SERVER['PHP_SELF']);

/*
 ***************************************************************************************************************************
 * Javascript
 ***************************************************************************************************************************
 */
	?>
<script language="javascript" type="text/javascript">
var cF=D.comForm;
function addContact(){
	if(document.newContact.name.value.length<5 || document.newContact.name.value.length>15){
		alert("<?php echo cfCaptionJS('accountNameFormat',5,15);?>");
		return;
	}
	if((document.newContact.type[0].checked || document.newContact.url.value.length>0) && document.newContact.name.value.length>0) document.newContact.submit();
}
function modifyContact(id){
	cF.data1.value=dgi('name'+id).innerHTML;
	cF.data2.value=dgi('notes'+id).value;
	cF.data3.value="modifyContact";
	document.comForm.submit();
}
function deleteContact(id){
	var check = confirm("<?php echo cfCaptionJS('genConfirmSuppress');?>\""+dgi('name'+id).innerHTML+"\" ?");
	if(!check) return;
	cF.data1.value=dgi('name'+id).innerHTML;
	cF.data3.value="deleteContact";
	document.comForm.submit();
}
D.body.onload=D.body.onresize=function(){alignBottom(dgi('contactsDiv'),winMe,10)}
</script>
	<?php
echo outDivFrame('frame1','id="contactsDiv"','overflow:auto');
echo '<div class="frame1Header">'.outImage(outicon('contacts'),false,false,'margin-right:1em').cfCaption('genContacts').'</div>';


/*
 ***************************************************************************************************************************
 * Display New contact form
 ***************************************************************************************************************************
 */
echo outDivFrame('frame2');
echo outFrameHeaderTable('frame2Header',outImage(outicon('new'),false,false,'margin-right:1em').cfCaption('contactNew'), outButton(cfCaption('genAdd'),'javascript:addContact()',outIcon('add')));
echo '<form name="newContact" method="post" enctype="multipart/form-data" action="'.$_SERVER['PHP_SELF'].'">';
echo cfCaption('accountName').'<input class="textInput" type="text" name="name" size="20" style="margin-left:1em; margin-right:2em"/>';
echo cfCaption('contactNotes').'<input class="textInput" type="text" name="notes" size="30" style="margin-left:1em;"/><br />';
echo '<input type="radio" name="type" value="reg" checked="checked">'.cfCaption('contactReg').'<br />';
echo '<input type="radio" name="type" value="unreg">'.cfCaption('contactUnreg');
echo '<span style="margin-left:2em;margin-right:1em;">'.cfCaption('contactURL').'</span><input class="textInput" type="text" name="url" size="20" />';
echo '<input type="hidden" name="resId" value="'.$_SESSION['activeResourceId'].'">';
echo '<input type="submit" value="s" style="position:absolute; top:-800px"><br/>';
echo "</form></div><br />\n";

/*
 ***************************************************************************************************************************
 * Display Contacts list
 ***************************************************************************************************************************
 */
$i=0;
foreach ($contacts as $name=>$value){
	echo '<fieldset style="display:inline;border:0;margin:1px;">';
	echo '<div style="display:inline;border:0;margin:1em;">';
	echo outDivFrame('frame2',false,'width:360px');

	// Icon & name
	if(isset($value['type']) && $value['type']=='reg') $l=outImage(outicon('logoSmall'),false,false,'margin-right:1em').cfUTF8Encode($name);
	elseif(isset($value['type']) && $value['type']=='unreg') $l=outImage(outicon('user'),false,false,'margin-right:1em').cfUTF8Encode($name);
	else $l=outImage(outicon('broken'),false,false,'margin-right:1em').cfUTF8Encode($name);
	if(cfRGetVar('advancedAdministration')) {
		echo outFrameHeaderTable('frame2Header',$l,outButton(cfCaption('genDelete'),'javascript:deleteContact('.$i.')',outicon('suppr')));
	}
	else echo '<div class="frame2Header">'.$l."</div>\n";
	echo '<div style="display:none" id="name'.$i.'">'.cfUTF8Encode($name).'</div>';
	echo outTableTransparent('frame2','table-layout:fixed;');
	echo '<tr style="text-align:center">';

	// Status & link
	echo '<td style="width:70px;">';
	if(isset($value['status']) && $value['status']===1) echo outImage('contactonline.png',cfSiteLink($name)).'<br />'.cfCaption('genStatus').cfCaption('genSeparator').cfCaption('contactOnLine');
	elseif(isset($value['status']) && $value['status']===0) echo outImage('contactOffline.png',cfSiteLink($name)).'<br />'.cfCaption('genStatus').cfCaption('genSeparator').cfCaption('contactOffLine');
	else echo outImage('contactUnknown.png',(isset($value['url']))?((strtolower(substr($value['url'],0,7))=='http://')?$value['url']:'http://'.$value['url']):(($value['type']=='reg')?cfSiteLink($name):false)).'<br />'.cfCaption('genStatus').cfCaption('genSeparator').cfCaption('contactULine');
	echo "</td>\n";
	echo '<td style="width:220px;">';

	// Notes
	echo '<textarea id="notes'.$i.'" style="width:100%" cols="30" rows="3" '.((cfRGetVar('advancedAdministration'))?'':' readonly').'>'.((isset($value['notes']))?cfUTF8Encode(str_replace("<br />","\n",$value['notes'])):'')."</textarea>\n";
	if(cfRGetVar('advancedAdministration')) echo '<br />'.outButton(cfCaption('genSave'),'javascript:modifyContact('.$i.')',outicon('save'));
	echo "</td></tr></table>";
	echo "</div>\n";
	echo "</div>\n";
	echo "</fieldset>\n";
	$i++;
}
// No contact
if(!count($contacts) && !cfRGetVar('advancedAdministration')) echo '<span style="padding-top:14em;padding-bottom:14em;text-align:center;display:block">'.cfCaption('contactNo')."</span>\n";
if(!count($contacts) && cfRGetVar('advancedAdministration')) echo '<span style="padding-top:5em;padding-bottom:5em;text-align:center;display:block">'.cfCaption('contactNo')."</span>\n";

echo "</div>\n";
?>
