<?php
/**
 * Photo album Layout 3 (checkerboard)
 *
 * Configuration of standard photo album resource
 * this script is included by /res/administration/std/resourceConfig.php
 * this script should never be directly called.
 *
 * resourceConfig.php sets 2 variables :
 * $resourceData (array) which contains resource parameters loaded from user.res file
 * $_ENV['configurationEnvironment'] which indicates if resourceConfig.php has been called from browser ('browser')
 * or from application's embeded browser ('application')
 *
 * PHP version 5
 *
 * LICENSE: This source file is subject to version 3.0 of the PHP license
 * that is available through the world-wide-web at the following URI:
 * http://www.php.net/license/3_0.txt.  If you did not receive a copy of
 * the PHP License and are unable to obtain it through the web, please
 * send a note to license@php.net so we can mail you a copy immediately.
 *
 * @category   NA
 * @package    NA
 * @author     Nicolas Bruley / Peer 2 World <contact@weezo.net>
 * @copyright  2005-2009 Nicolas Bruley / Peer 2 World
 * @license    http://www.php.net/license/3_0.txt  PHP License 3.0
 * @version    CVS: $Id:$
 * @link       http://www.weezo.net
 * @since      File available since Release 1.0.0
 */

// Photo 3 sub-layout: 0=> preview + 1 line of tn 1=>preview + mosaic, 2: mosaic only
$subLayout=substr(cfRGetVar('combinedLayout'),-1);

/*
 ***************************************************************************************************************************
 * Insert Photo title, and combined layout selector
 ***************************************************************************************************************************
 */
photoHeader();

/*
 ***************************************************************************************************************************
 * Start of resource specific section
 ***************************************************************************************************************************
 */

echo outTableTransparent(false,'').'<tr>'; // Main layout table


/*
 ***************************************************************************************************************************
 * Action panel (multiple downloads, image upload, navigation)
 ***************************************************************************************************************************
 */
if(efActionPanelDisplayed()) {
	efActionPanel('left',false,array('shadows'=>1,'panelExtraHTML'=>''));
	echo '<td id="leftTD" style="vertical-align:top;width:auto;position:relative">';
}
else echo '<td style="vertical-align:top;width:100%;position:relative">';


/*
 ***************************************************************************************************************************
 * Preview
 ***************************************************************************************************************************
 */
echo outDivFrame('frame1','id="previewFrame"',(($subLayout==2)?';display:none':''));
echo '<center>';
echo $preview->image('width:90%;height:400px'.(($subLayout==2)?';display:none':''));
echo '</center>';
echo "</div>\n\n";


/*
 ***************************************************************************************************************************
 * Thumbnails
 ***************************************************************************************************************************
 */
echo outDivFrame('frame1','id="thumbnailsFrame"');
$l='<span id="previewControls"'.(($subLayout==2)?' style="display:none"':'').'>';

// Preview area title area content
$l.=/*$preview->previousBt().'&nbsp;&nbsp;'.*/$preview->toggleSlideshowBt(false)/*.'&nbsp;&nbsp;'.$preview->nextBt()*/;
// Edit image's comments button
$l.=$preview->editCommentsBt();
// Download full size button & zip download buttons
$l.='&nbsp;&nbsp;'.$preview->downloadBts(false);
// Preview image rotation buttons
$l.='&nbsp;&nbsp;'.$preview->rotateBts();
// View button
$l.='&nbsp;&nbsp;'.$preview->viewBt(false,true);
$l.='</span>';


// Sort controls
$r=outFileSortControls(true);

// Thumbnails interval selection controls
$r.=outExplorerThumbnailsSelector(1,true);

// File search
if(cfRGetVar('searchFiles')) $r.='&nbsp;'.outButton(false,'javascript:searchFiles()',outIcon('search'),cfCaption('genSearch'));

echo outFrameHeaderTable('',$l,' '.$r,'id="thumbnailsFrameHeader"');

// List or icons view
echo '<div id="noFileDiv" style="overflow:auto;position:relative;height:300px"></div>';
echo '<center id="thumbnailsFrameBottom">'."</center></div>\n";

echo '</div>'; // Close thumbnailsPanel

echo '</td></tr></table>'; // Close main layout table

echo '</div>'; // close topDiv

?>
<script type="text/javascript">
function winResized(){
	var pOF=dgi('previewOuterFrame');

	pOF.style.display=(subLayout==2)?'none':'';
	dgi('noFileDiv').style.overflow=(subLayout==0)?'hidden':'auto';
	if(subLayout==0){
		pOF.style.height=(Math.max(50,winMe.getInnerHeight()-actualOffsetTop(pOF)-Math.max(64,tnWidth)-dgi('thumbnailsFrameHeader').offsetHeight-30))+'px';
	}
	else if(subLayout==1){
		pOF.style.height=Math.max(50,Math.min(winMe.getInnerHeight()*0.45,450))+'px';
	}
	else if(subLayout==2){}

	alignBottom(dgi("noFileDiv"),winMe,15);

	alignBottom(dgi("thumbnailsFrame"),winMe,10);

<?php if(cfRGetVar('treeViewDisplayed')){ ?>
	if(dgi('actionsPanel').style.display!='none') alignBottom(dgi("<?php echo $tree->HTMLDivID();?>"),dgi("thumbnailsFrame"),0);
<?php } ?>
	preview.frameResized();
}
var layout3State;
function layout3Load(i){
	layout3State[i]=1;
	var n=dgi('_id'+i);
	if(!n) return;
	if(n.tagName!='IMG') n=n.firstChild;
	n.src=n.getAttribute('aalt');
}
function layout3Loaded(n){
	var l=fL.files.length;
	if(l<50) fade(n,0,1,10); else n.style.visibility='visible';
	for(i=0;i<l;i++) if(!layout3State[i]) {layout3State[i]=1;setTimeout('layout3Load('+i+')',1);return}
}

// Before tn gen
function filesListBeforeDraw(files,tnw,tnh){
	if(animTimerSet) clearInterval(animTimer); animTimerSet=0;
	if(dd.elements['dragMaskDiv']) dd.elements['dragMaskDiv'].del()
	if(subLayout!=2) preview.set((files.length)?files[0][2]:'foo');
}
// After tn gen
function filesListAfterDraw(files,tnw,tnh){
	if(!dd.elements['dragMaskDiv']) ADD_DHTML('dragMaskDiv'+HORIZONTAL+CURSOR_HAND);

	layout3State={}
	for(var i=0;i<Math.min(10,fL.files.length);i++) layout3Load(i);

}

// tn gen
function filesLayoutResource(files,tnw,tnh){
	var f,i,o;
	tnh=tnw;
	fL.noLeftClickCM=1;
	fL.previewOnCM=(subLayout==2)?view:1; // Sublayout 3: view on click
	fL.noTooltip=(subLayout!=2);

	if(subLayout==0){
		winResized()
		o='<table id="filesTable" style="width:100%;height:100%;table-layout:fixed" cellspacing=0 cellpadding=0 onmousemove="scrollPlaceMask(event)"><tr style="vertical-align:middle">';
		o+='<td style="width:68px"><img onclick="scroll2Left()" id="scrollLeftBt" style="width:64px;height:64px;cursor:pointer" src="<?php echo outIcon('photoPrev');?>"></td>';
		o+='<td><div id="tnOuter" style="position:relative;overflow:hidden;height:'+tnh+'px">';
		o+='<div id="tnScrollBar" style="position:absolute;white-space:nowrap;width:'+(tnw*files.length)+'">';
		for(i=0;i<files.length;i++) {
			f=files[i];
			o+='<img id="_id'+i+'" style="visibility:hidden;width:'+tnw+'px;height:'+tnh+'px;" onload="layout3Loaded(this)" aalt="'+f[17]+'"><div id="id'+i+'" style="display:none">'+f[2]+'</div>';
		}
		o+='</div>';
		o+='<div style="position:absolute;width:'+tnw+'px;height:'+tnh+'px;background:black;<?php echo outCssOpacity(1);?>" ondblclick="scrollDragClick(1)" onmousedown="scrollDragStart()" id="dragMaskDiv"></div>'
		o+='</div></td><td style="width:68px"><img onclick="scroll2Right()" id="scrollRightBt" style="width:64px;height:64px;margin-left:4px;cursor:pointer" src="<?php echo outIcon('photoNext');?>"></td></tr>';
		return o+'</table>';
	}
	o='<div id="filesTable">';
	for(i=0;i<files.length;i++) {
		f=files[i];
		u='<fieldset id="'+((f[1]=='d')?'d':'f')+i+'" onmouseup="fL.cm(this,event)" onmouseover="if(!fL.noTooltip) tooltip(this,fL.tt)" style="width:'+tnw+';height:'+tnh+';padding:0;margin:0;vertical-align:top;cursor:pointer">';
		u+='<div id="_id'+i+'" style="position:relative;width:'+tnw+';height:'+tnh+'" onmousedown="fL.sDF(this,\'\',event)">';
		u+='<img style="visibility:hidden;width:'+tnw+'px;height:'+tnh+'px" onload="layout3Loaded(this)" aalt="'+f[17]+'">';
		u+='</div>';
		u+='<div id="id'+i+'" style="display:none">'+f[2]+'</div>';
		o+=u+'</fieldset>';
	}
	return o+'</div>';
}
function layoutSubLayoutChanged(nl){
	var pOF=dgi('previewOuterFrame'),nsl=nl.substr(1,1), pl=combinedLayout;redrawTN=1,pCS=dgi('previewControls').style;
	if(nl=='32') {pOF.style.display='none'; pCS.display='none'}
	if(pl=='32') {pOF.style.display=''; pCS.display='';if(preview.currentImg()) preview.currentImg().style.height=''}
	if((nsl==2 && subLayout==1) || (nsl==1 && subLayout==2)) redrawTN=0;
	combinedLayout=nl;
	subLayout=nl.substr(1,1);
	winResized();
	if(redrawTN) fL.draw();
	else if(subLayout!=2) {
		fL.previewOnCM=1;
		fL.noLeftClickCM=1;
		fL.noTooltip=1;
	}
	else{
		fL.previewOnCM=0;
		fL.noLeftClickCM=0;
		fL.noTooltip=0;
	}
	if(pl==32) W.setTimeout('preview.set()',50);
	return 1;
}

// Scroll functions
var tnSBP=0,targetX=0,animTimer,animTimerSet=0,sDStartX=-1,sDStartY,sDPrevX,sDDX,sDStartSBPos,sDTimer,sDTimer;
function tmp(){}
function scrollPlaceMask(e){
	if(!dd.obj) {updateMousePosition(e);dd.elements.dragMaskDiv.moveTo(mouseX-tnWidth/2,false)}
}
function scroll2Left(){
	targetX+=Math.max(dgi('tnOuter').offsetWidth,2*tnWidth);
	if(tnSBP>-tnWidth/3) {
		tnSBP=tnWidth/2;
		dgi('tnScrollBar').style.left=tnSBP+'px'
	}
	scrollAnim();
}
function scroll2Right(){
	targetX-=Math.max(dgi('tnOuter').offsetWidth,2*tnWidth);
	if(tnSBP<dgi('tnOuter').offsetWidth - dgi('tnScrollBar').offsetWidth+tnWidth/3){
		tnSBP=dgi('tnOuter').offsetWidth - dgi('tnScrollBar').offsetWidth-tnWidth/2;
		dgi('tnScrollBar').style.left=tnSBP+'px'
	}
	scrollAnim();
}
function scrollAnim(){
	if(animTimerSet) clearInterval(animTimer);
	targetX=Math.min(targetX,0);
	targetX=Math.max(targetX,dgi('tnOuter').offsetWidth - dgi('tnScrollBar').offsetWidth);
	var delta=targetX-tnSBP;
	if(Math.abs(delta)<1)	{
		tnSBP=targetX;
	}
	else {
		tnSBP+=delta/6;
		animTimer=setTimeout('scrollAnim()',50);
		animTimerSet=1;
	}
	if(!isNaN(tnSBP)) dgi('tnScrollBar').style.left=tnSBP+'px';
}
function updatePosition(){
	if(sDStartX<0) return;

	var tSB=dgi('tnScrollBar'),dte=new Date();
	if(dte.getTime()-sDTimer>0) {
		sDDt=dte.getTime()-sDTimer;
		sDTimer=dte.getTime();
		sDDX=mouseX-sDPrevX;
		sDPrevX=mouseX;
	}
	tnSBP=sDStartSBPos+mouseX-sDStartX;
	if(tnSBP>0) tnSBP=Math.pow(tnSBP,0.85);
	if(tnSBP < dgi('tnOuter').offsetWidth - tSB.offsetWidth)
		tnSBP=dgi('tnOuter').offsetWidth - tSB.offsetWidth-Math.pow(dgi('tnOuter').offsetWidth - tSB.offsetWidth - tnSBP,0.85);
	tSB.style.left=tnSBP+'px';

	if(!mouseEvt.but) return scrollDragStop();
}
function scrollDragStart(){
	dd.elements['dragMaskDiv'].dropFunc=scrollDragStop;
	if(animTimerSet) clearInterval(animTimer);

	if(dgi('tnScrollBar').offsetWidth>dgi('tnOuter').offsetWidth) {animTimer=setInterval('updatePosition()',10);animTimerSet=1;}
	sDStartX=mouseX;
	sDStartY=mouseY;
	sDPrevX=mouseX;
	sDStartSBPos=dgi('tnScrollBar').offsetLeft;
	sDTimer=sDTimer=(new Date()).getTime();
	sDDt=0;
}
function scrollDragStop(){
	if(sDStartX<0) return;

	if(animTimerSet) clearInterval(animTimer); animTimerSet=0;

	var dist=Math.pow(sDStartX-mouseX,2)+Math.pow(sDStartY-mouseY,2)
	sDStartX=-1;
	targetX=tnSBP;

	if(dist<100) return scrollDragClick(0);

	targetX=tnSBP+sDDX*8;
	scrollAnim();
}
function winMouseOut(){
	scrollDragStop()
}
function scrollDragClick(isDblClick){
	var n=dgi('tnScrollBar').firstChild,l;
	while(n){
		if(n.tagName=='IMG'){
			l=actualOffsetLeft(n);
			if(l<=mouseX && l+tnWidth>=mouseX ) {
				if(isDblClick) view(n.id.substr(1)); else preview.set(n.id.substr(1));
				return;
			}
		}
		n=n.nextSibling;
	}
}
winResized();
</script>
<?php
// Drag'n drop registration
echo cfDragRegisterItems();
// Fill thumbnails
efFilesList("noFileDiv",array('commitDraw'=>true,'crop'=>cfRGetVar('cropThumbnails')));
?>
</body>
</html>
<?php
exit;